%define vers    7.5-1.6.99.1-20090304
Name:           Xorg
Version: 	7.5_1.6.99.1_20090304
Release: 	1
Copyright: 	GPL
Summary: 	The basic programs for your X workstation.
Group: 		Libraries
URL:		http://x.org/
Source0: 	xc.tar.bz2
Source1:	mesa.tar.bz2
Source2:        git_xorg
Source3:	xorg.tar.bz2
Patch0:		build.sh.diff
Patch1:         ErrHndlr.c.diff
Patch2:         XlibInt.c.diff
Patch3:         Xlibint.h.diff
BuildRoot: 	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)
Provides:	xorg x11 X11 X11R6 xfree86 XFree86
BuildRequires:	gperf-devel Xorg-libdrm-devel Xorg-Mesa-dri-devel gtk-doc-devel
%define		_sysconfdir	/etc/X11
#define __spec_install_post /usr/lib/rpm/brp-compress

%description
Release %{name} %{vers}:
X-Windows maintains the base structure GUI environment for desktop
managers such as KDE & GNOME or Window Managers Enlightenment, ICE,
etc ... they extend the X-Windows GUI with more nice widget libraries 
such as QT-Troll-Tech or GTK. This release also contains the next 
generation of MESA GL and xft2/fontconfig/freetype2; libraries.

Lets try to keep the build simple, as the usual one tarball, not 300
crazy f'n packages.

XGL/DMX disabled until somebody fixes it. ERROR xf86Keymap.h not found.
Its OK, AIGLX is now auto-built into the 'Xorg' server. XGL is still
fun though, to play around with. You might have with  Mesa EGL, too.

Use the sOuRCe luke! Req. git and the git_xorg script.
 git_xorg (cd into the source)
Remove .git tags: find . -depth -name .git* -exec rm -fr {} \;

Browse: http://cgit.freedesktop.org/xorg/

Use tarballs, none available.
wget --retr-symlinks ftp://ftp.freedesktop.org/pub/xorg/development/X11R7.4/everything/*bz2

Resume build (usefull), i.e. "-r app/xdpyinfo /usr/X11R6"
Oth'r notes to lk: If the build failes w/ xproxymngproto not found; it
means install pmproto.

Check build version xc/xserver/configure.ac

%package 	devel
Summary: 	Xorg static libraries, headers and programming man pages.
Group: 		Development
Provides: 	xorg-devel x11-devel X11-devel xfree86-devel XFree86-devel
%description 	devel
For developers or developing X-Windows based applications..

%package 	man
Summary: 	Xorg manual. Instruction pages.
Group: 		System
%description 	man
Information 	X-manual.

%prep
%setup -q -n xc -a 1
%patch0 -p0
%patch1 -p0
%patch2 -p0
%patch3 -p0
rm -r xcb/libxcb; rm -r xcb/proto

%build
if [ -d xcb ]; then
    xcb/pthread-stubs/autogen.sh --prefix=/usr/X11R6; make; make install; rm -r xcb
fi

# They still create a silly sym-link - soooo ... not using /usr nor /usr/X11R7 - remain out-dated ;-)
./util/modular/build.sh --prefix=/usr/X11R6 --with-mesa-source=/usr/src/redhat/BUILD/xc/mesa/ \
--disable-dmx --disable-xgl --enable-xglx --enable-xegl --enable-aiglx --enable-dri --enable-glx \
--disable-kdrive --enable-xorg --enable-xvfb --enable-xnest --disable-xprint --with-xcb=no USE_XCB=NO \
--sysconfdir=/etc --localstatedir=/var -m /usr/src/redhat/BUILD/xc/mesa/ /usr/X11R6

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/{doc,include,lib/pkgconfig}; mkdir -p $RPM_BUILD_ROOT/usr/share/aclocal
cp -r /usr/X11R6 $RPM_BUILD_ROOT/usr; rm -r $RPM_BUILD_ROOT/usr/X11R6/var
ln -sf /etc $RPM_BUILD_ROOT/usr/X11R6/etc
ln -sf /var $RPM_BUILD_ROOT/usr/X11R6/var
mkdir $RPM_BUILD_ROOT/etc; mv $RPM_BUILD_ROOT/usr/X11R6/lib/X11 $RPM_BUILD_ROOT/etc/
ln -sf /etc/X11 $RPM_BUILD_ROOT/usr/X11R6/lib/X11
mv $RPM_BUILD_ROOT/usr/X11R6/share/X11/* $RPM_BUILD_ROOT/etc/X11; rmdir $RPM_BUILD_ROOT/usr/X11R6/share/X11
ln -sf /etc/X11 $RPM_BUILD_ROOT/usr/X11R6/share/X11; mv $RPM_BUILD_ROOT/usr/X11R6/lib/xorg/modules $RPM_BUILD_ROOT/usr/X11R6/lib/
ln -sf ../modules $RPM_BUILD_ROOT/usr/X11R6/lib/xorg/modules
mv $RPM_BUILD_ROOT/usr/X11R6/share/icons $RPM_BUILD_ROOT/etc/X11; ln -sf ../../../etc/X11/icons $RPM_BUILD_ROOT/usr/X11R6/share/icons
cd $RPM_BUILD_ROOT/usr/lib; ln -sf ../X11R6/lib/lib* .
cd $RPM_BUILD_ROOT/usr/X11R6/include; ln -sf X11/* .; ln -sf xorg/* .; ln -sf pixman-1/* .
cd $RPM_BUILD_ROOT/usr/include; ln -sf ../X11R6/include/* .
cd $RPM_BUILD_ROOT/usr/share/aclocal; ln -sf ../../X11R6/share/aclocal/* .
cd $RPM_BUILD_ROOT/usr/lib/pkgconfig; ln -sf ../../X11R6/lib/pkgconfig/* .
mv $RPM_BUILD_ROOT/usr/X11R6/share/man $RPM_BUILD_ROOT/usr/
ln -sf /usr/X11R6/share/doc $RPM_BUILD_ROOT/usr/doc/%{name}-%{vers}
tar xjpf %{SOURCE3} -C $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT/usr/share/locale; cd $RPM_BUILD_ROOT/usr/share/locale
ln -sf ../../X11R6/lib/X11/locale/compose.dir .
ln -sf ../../X11R6/lib/X11/locale/locale.alias .
ln -sf ../../X11R6/lib/X11/locale/locale.dir .

# glibc-devel conflict
rm $RPM_BUILD_ROOT/usr/include/{shadow.h,shadowfb.h}
# vesautils-devel conflict
rm $RPM_BUILD_ROOT/usr/include/vbe.h
# gc-devel conflict
rm $RPM_BUILD_ROOT/usr/include/gc.h
# Crashes our system w/ X -configure
rm $RPM_BUILD_ROOT/usr/X11R6/lib/modules/drivers/sunffb*

# Correct permissions
chmod 4755 $RPM_BUILD_ROOT/usr/X11R6/bin/{Xorg,Xnest,Xvfb,startx}

strip -g -x -X $RPM_BUILD_ROOT/usr/X11R6/lib/modules/* 2>/dev/null || :
strip -g -x -X $RPM_BUILD_ROOT/usr/X11R6/lib/modules/drivers/* 2>/dev/null || :
strip -g -x -X $RPM_BUILD_ROOT/usr/X11R6/lib/modules/extensions/* 2>/dev/null || :
strip -g -x -X $RPM_BUILD_ROOT/usr/X11R6/lib/modules/fonts/* 2>/dev/null || :
strip -g -x -X $RPM_BUILD_ROOT/usr/X11R6/lib/modules/input/* 2>/dev/null || :
strip -g -x -X $RPM_BUILD_ROOT/usr/X11R6/lib/modules/linux/* 2>/dev/null || :
strip -g -x -X $RPM_BUILD_ROOT/usr/X11R6/lib/modules/multimedia/* 2>/dev/null || :

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
/etc
/usr/X11R6/etc
/usr/X11R6/lib/lib*.so*
/usr/X11R6/lib/*.la
/usr/X11R6/lib/X11
/usr/X11R6/lib/modules
/usr/X11R6/lib/xorg
/usr/X11R6/bin
/usr/X11R6/include/X11/bitmaps
/usr/X11R6/include/bitmaps
/usr/X11R6/include/pixman-1
/usr/lib/lib*.so*
/usr/lib/*.la
/usr/X11R6/share/X11
/usr/X11R6/share/icons
/usr/X11R6/var
/usr/share/locale

%files devel
%defattr(-,root,root)
/usr/X11R6/lib/*.a
/usr/X11R6/lib/pkgconfig
/usr/X11R6/include/GL
/usr/X11R6/include/ICE
/usr/X11R6/include/SM
/usr/X11R6/include/Xaw
/usr/X11R6/include/Xcursor
/usr/X11R6/include/Xft
/usr/X11R6/include/Xmu
/usr/X11R6/include/Xtrans
/usr/X11R6/include/dri
/usr/X11R6/include/extensions
/usr/X11R6/include/fonts
/usr/X11R6/include/xorg
/usr/X11R6/include/X11/ICE
/usr/X11R6/include/X11/SM
/usr/X11R6/include/X11/Xaw
/usr/X11R6/include/X11/Xcursor
/usr/X11R6/include/X11/Xft
/usr/X11R6/include/X11/Xmu
/usr/X11R6/include/X11/Xtrans
/usr/X11R6/include/X11/dri
/usr/X11R6/include/X11/extensions
/usr/X11R6/include/X11/fonts
/usr/X11R6/include/X11/*.h
/usr/X11R6/include/*.h
/usr/X11R6/share/aclocal
/usr/share/aclocal
/usr/lib/lib*.a
/usr/lib/pkgconfig
/usr/include

%files man
%defattr(-,root,root)
/usr/man
/usr/X11R6/share/doc
/usr/doc
